   PROGRAM

 INCLUDE('xlsxwriter.inc')

xlsx   &xlsxwriter

options1  GROUP(imageoptions)
     END

Window WINDOW('Xlsx'),AT(,,312,107),FONT('MS Sans Serif',8,,FONT:regular),TIMER(100),SYSTEM,GRAY,DOUBLE
       BUTTON('  xlsx'),AT(108,38,100,14),USE(?Button)
     END

  Map
    PictureToSquare(xlsxwriter,long,long,string,long,long),byte
  end

 CODE

    Open(Window)

    settarget(window)
    accept
      case event()
      of Event:Accepted
        case Field()
        OF ?Button
            xlsx &=NEW(xlsxwriter)
            xlsx.NewWorkbook('Report.xlsx')
            worksheet#=xlsx.AddWorksheet('1')
            xlsx.ClearFormat()
            xlsx.Format.BorderStyle=XLSX:BorderLeft+XLSX:BorderTop+XLSX:BorderRight+XLSX:BorderBottom
            xlsx.Format.Color=color:yellow
            xlsx.SetFormat()
            err#=xlsx.WriteNumber(1,1,123.45)
            err#=xlsx.WriteNumber(2,1,346.67)
            xlsx.Format.Color=color:red
            xlsx.SetFormat()
            err#=xlsx.WriteFormula(3,1,'=SUM(A1:A2)')

            xlsx.ClearFormat()

            err#=xlsx.WriteBoolean(5,1,1)

            err#=xlsx.Merge(3,3,5,5)
            xlsx.Format.FontSize=18
            xlsx.Format.FontColor=color:red
            xlsx.Format.FontStyle=FONT:Bold
            xlsx.Format.Align=XLSX:ALIGN_CENTER 
            xlsx.Format.AlignV=XLSX:ALIGN_VERTICAL_CENTER
            xlsx.SetFormat()
            err#=xlsx.WriteString(3,3,'!')

            xlsx.ClearFormat()
            xlsx.Format.FontColor=color:blue
            xlsx.Format.FontStyle=FONT:Underline
            xlsx.SetFormat()
            err#=xlsx.WriteUrl(7,1,'http://www.clarionlife.net')

            xlsx.ClearFormat()

!!! Only if you have Taboga Native Excel.
!!! _TPICTLinkMode_=>1
!!! _TPICTDllMode_=>0
!!! must be defined
            xlsx.Format.Picture='@d6-'
!!!

            xlsx.SetFormat()
            err#=xlsx.WriteDateTime(8,1,today(),clock())
            err#=xlsx.SetColumn(1,1,10)

            options1.x_offset=10
            options1.y_offset=15
            options1.x_scale=2
            options1.y_scale=2

!            loop i#=1 to 600
              err#=xlsx.InsertImage(i#+10,1,'image002.png',options1)
!              err#=xlsx.InsertImage(i#+10,1,'image002.png')
               if err#
!                stop(i#)
                stop(xlsx.StrError(err#))
              end
!            end
                                    
  ! ---     F12 (Row = 12, Column = 6) ---------------

  xlsx.ClearFormat()
  xlsx.SetFormat()

  err# = xlsx.SetColumn(6,6,14.71)   ! = 108  (100  + 2   4)
  err# = xlsx.SetRow(12,81)          ! = 108  (100  + 2   4)

  !     

  xlsx.Format.BorderStyle=XLSX:BorderLeft+XLSX:BorderTop+XLSX:BorderRight+XLSX:BorderBottom
  xlsx.SetFormat()
  err# = xlsx.WriteBlank(12,6)

  !      100x100   4

  If PictureToSquare(xlsx,12,6,'test.jpg',100,4).

  ! ----------------------------------------------------------------------

            err#=xlsx.CloseWorkbook()
            dispose(xlsx)
        end
        display
      end
    end
    close(window)

! ---     

PictureToSquare  Procedure(MyXLSX,xRow_,xCol_,xFileName_,xSize_,xOffset_)

Loc:RetValue         BYTE(False)
Loc:Image            SHORT
Loc:Offset           LONG
Loc:Scale            REAL
Loc:ErrorCode        LONG
Loc:ImageOptions     GROUP(imageoptions),PRE(),STATIC
                     END

  Code

  Loc:Image = Create(0,Create:Image)

  If Loc:Image

     Loc:Image{Prop:Text} = Clip(xFileName_)
     If Clip(Loc:Image{Prop:Text}) <> ''

        0{Prop:Pixels} = True      !       

        Loc:Scale  = xSize_ / Choose(Loc:Image{Prop:Width} > Loc:Image{Prop:Height},Loc:Image{Prop:Width},Loc:Image{Prop:Height})
        Loc:Offset = Round((Abs(Loc:Image{Prop:Width} - Loc:Image{Prop:Height}) * Loc:Scale) / 2,1)

        Clear(Loc:ImageOptions)
        Loc:ImageOptions.x_offset = xOffset_ + Choose(Loc:Image{Prop:Width} > Loc:Image{Prop:Height},0,Loc:Offset)
        Loc:ImageOptions.y_offset = xOffset_ + Choose(Loc:Image{Prop:Width} > Loc:Image{Prop:Height},Loc:Offset,0)
        Loc:ImageOptions.x_scale  = Loc:Scale
        Loc:ImageOptions.y_scale  = Loc:Scale

        0{Prop:Pixels} = False     !  

        If ~MyXLSX.InsertImage(xRow_,xCol_,xFileName_,Loc:ImageOptions) then Loc:RetValue = True.
     end

     Destroy(Loc:Image)
  end

  Return(Loc:RetValue)